const jalaaliHelper = require('./JalaliHelper');
const util = require("util");

function getPaymentResult(isSuccessful, trackId, amount, timestamp) {
    const date = new Date(timestamp * 1000);
    let persianDateText = jalaaliHelper.toJalaliDateText(date)
    persianDateText += ` ${date.getHours()}:${date.getMinutes()}`

    return util.format(this.Payment.base,
        trackId,
        amount,
        persianDateText
    )
}

function convertToPersianNumber(number) {
    const persianDigits = ['۰', '۱', '۲', '۳', '۴', '۵', '۶', '۷', '۸', '۹'];
    const numberString = number.toString();
    let persianNumber = '';

    for (let i = 0; i < numberString.length; i++) {
        const digit = parseInt(numberString[i]);
        if (!isNaN(digit)) persianNumber += persianDigits[digit];
        else persianNumber += numberString[i];
    }

    return persianNumber;
}




module.exports = {
     getPaymentResult,convertToPersianNumber,
    Payment: {
        success: "پرداخت موفق بود.",
        unsuccess: "پرداخت شما ناموفق بوده است.",
        base: "کدپیگیری: %s\nمبلغ: %s\nزمان: %s",
        failToCreate: 'متاسفانه اتصال به درگاه پرداخت موفق نبود.',
        notInStep: 'شما در مرحله پرداخت نیستید.',
        needToPay: "شما هنوز مبلغ فرانشیز را پرداخت نکردید.",
    },
    Assessment: {notActive:"ارزیابی فعالی برای شما پیدا نشد.",notFound: 'ارزیابی شما پیدا نشد. با پشتیبانی تماس بگیرید.',pregnancy:'لطفا تایید کنید که باردار نیستید.',p2Empty:'لطفا حداقل یک ناحیه درد را مشخص کنید.'},
    sessionExpire: "نشست کاربری شما منقضی شده است. نیاز است دوباره وارد حساب خود شوید",
    needAuth: "you need a authentication token",
    returnToPay: "بازگشت به صفحه پرداخت",
    UserAuthInfoInvalid: "اطلاعات ورود به حساب شما دچار تداخل شده است. اگر از صحت عملکرد خود مطمئن هستید با پشتیبانی تماس بگیرید",
    OK: "موفق بود",
    needLoginBeforeContinue: "برای ادامه کار نیاز است ایمیل خود را ثبت کنید",
    AccessDenied: "دسترسی شما محدود شده است",
    OTP: {
        sent: "کد برای شماره همراه ارسال شد",
        fail: "کد وارد شده اشتباه است. لطفا مجدد تلاش کنید",
        sendFail: "در فرایند ارسال کد مشکلی پیش آمده. این مشکل از سرور است. در زمان دیگری مجددا تلاش کنید",
        verified: "کد تایید شد. خوش آمدید",
        tooEarly: "حداقل فاصله بین درخواست پیامک دو دقیقه است.",
    },
    User: {
        notFound: "کاریری با این مشخصات وجود ندارد.",
        noValidPhone: "شماره تلفن وارد شده معتبر نیست.",
        notVerified: "هنوز شماره همراه شما تایید نشده است، لطفا مجددا اقدام به ورود به سامانه کنید",
    },
    Treatment: {
        notValid: "هنوز وضعیت درمان خود را مشخص نکردید.",
        notFound: "هیچ برنامه درمانی برای شما پیدا نشد.",
        notActive: 'برنامه درمانی شما فعال نیست.',
        fail: "مشکلی در پیدا کردن ویدئو‌های درمان ایجاد شده است.",
    },
    RedFlag: {
        notValid: "هنوز وضعیت درمان خود را مشخص نکردید.",
        notFound: "شما نیاز است ارزیابی را مجددا انجام دهید. لذا نسبت به ریست کردن ارزیابی از منو بالا اقدام کنید.",
        notActive: 'برنامه درمانی شما فعال نیست.',
        fail: "مشکلی در پیدا کردن ویدئو‌های درمان ایجاد شده است.",
    },
    UserIsNotInTreatmentStep: "شما در مرحله تمرینات نیستید.",
    UserIsNotInPaymentStep: "",
    MinStep: "شما در حال حاضر امکان برگشت به عقب را ندارید.",
    InvalidPId: "Internal Error: The given phone number is invalid.",
    InvalidCharacters: "Internal Error: The string contains invalid characters.",
    InvalidLength: "Internal Error: The string length is more then legal length.",
    InvalidEmail: "Internal Error: The given email is invalid.",
    InvalidNumber: "Internal Error: The given number is out of band.",
    InvalidInput: "Internal Error: The given option is out of band.",
    startDedicatedAssessment: "شروع ارزیابی اختصاصی",
}