const express = require('express');
const router = express.Router();

const authHelper = require("../Helper/AuthHelper");

const userController = require("../Controller/UserController");
const paymentController = require("../Controller/PaymentController");
const responseHelper = require("../Helper/ResponseHelper");
const relationController = require("../Controller/RelationController");
const assessmentsController = require("../Controller/AssessmentsController");

router.post("/paymentResult", authHelper.auth, (req, res) => {
    const userId = req.userId;
    res.json({success: true, message: "", data: require('../Helper/QuestionHelper').paymentResult})

    /* userController.getUserStep(userId)
        .then(userStep => userStep.startsWith("P") ? paymentController.verifyPayment(userId) : Promise.reject(responseHelper.Payment.notInStep))
        .then(isSuccessAndMessage => {
            const paymentResult = questionHelper.paymentResult;
            paymentResult.body.success = isSuccessAndMessage.isSuccessful
            paymentResult.body.body = isSuccessAndMessage.paymentResult
            paymentResult.body.title = isSuccessAndMessage.isSuccessful ? responseHelper.Payment.success : responseHelper.Payment.unsuccess
            paymentResult.body.buttonBody = isSuccessAndMessage.isSuccessful ? responseHelper.startDedicatedAssessment : responseHelper.returnToPay;

            res.json({success: true, message: "", data: paymentResult})
        }).catch(onRejected)
*/
    function onRejected(error) {
                res.json({success: false, message: error, data: {}})
    }
})


router.post("/getPaymentData", authHelper.auth, (req, res) => {
    const userId = req.userId;
    const {accessToken} = req.body;

    let userStep, registeredLabel, pId, element, childrenIds, response;
    userController.getUserStep(userId)
        .then(_userStep => {
            if (_userStep === "P") {
                userStep = _userStep;
                return assessmentsController.getAssessmentAnswer(userId, relationController.FIELDS.name)
            } else res.json({success: false, message: responseHelper.Payment.notInStep, data: []})
        })
        .then(_name => {
            registeredLabel = _name;
            return userController.getUserPId(userId)
        })
        .then(_pId => {
            pId = _pId;
            return paymentController.preparePayment(userId, _pId, registeredLabel, accessToken)
        })
        .then(paymentLink => paymentController.getPaymentForm(paymentLink))
        .then(payment=> res.json({success: true, message: "", data: payment}))
        .catch(onRejected)

    function onRejected(error) {
                res.json({success: false, message: error, data: {}})
    }
});

module.exports = router;