const express = require('express');
const router = express.Router();

const authHelper = require("../Helper/AuthHelper");

const userController = require("../Controller/UserController");
const treatmentController = require("../Controller/TreatmentController");
const paymentController = require("../Controller/PaymentController");
const assessmentController = require("../Controller/AssessmentsController");
const relationController = require("../Controller/RelationController");

const nextFormHelper = require("../Helper/NextFormHelper");

router.post("/updateTreatmentStatus", authHelper.auth, async (req, res) => {
    const userId = req.userId;
    let {newStatus, accessToken} = req.body;
    let registeredLabel, pId, assessment;

    try {

        await treatmentController.updateState(userId, newStatus)

        let userStep = await userController.getUserStep(userId)

        if (userStep.startsWith('DT'))
            nextFormHelper.nextOfTreatment(userId)
                .then(form => res.json({success: true, message: "", data: form}))
        else //or its GT
            return Promise.all([
                userController.getUserPId(userId),
                assessmentController.getAssessment(userId),
                userController.updateStep(userId, 'PG')
            ])
                .then(results => {
                    pId = results[0];
                    assessment = results[1];
                    registeredLabel = assessment[relationController.FIELDS.name];
                    return assessmentController.update(assessment.id, {lastUpdateUserStep: 'd3'})
                })
                .then(() => paymentController.preparePayment(userId, pId, registeredLabel, accessToken))
                .then(paymentLink => paymentController.getPaymentForm(paymentLink))
                .then(payment => res.json({success: true, message: "", data: payment}))
    } catch (e) {
        onRejected(e)
    }

    function onRejected(error) {
        res.json({success: false, message: error, data: {}})

    }
})

module.exports = router;